import subprocess


class GitRepo:
    """Class for gathering data about a Git repository."""

    def __init__(self, repo_url):
        self.repo_url = repo_url

    def ls_remote(self):
        """Run ls_remote for this repository."""
        return subprocess.check_output(['git', 'ls-remote',  '--heads',
                                        self.repo_url])

    def list_remote_branch_tips(self):
        """Iterate through (branch, commit) for this repository."""
        for line in self.ls_remote().splitlines():
            commit, ref = line.split('\t')
            branch = ref.split('/', 3)[2]
            yield branch, commit
